(*
  固有振動数の計算
*)

open Format
open Bigarray

open Lacaml.D
open Lacaml.Io

let k = 1.
let m = 1.

let modal_mat = [|
  [| 2. *. k /. m; -. (k /. m); 0. |];
  [| -. (k /. m); 2. *. k /. m; -. (k /. m)|];
  [| 0. ; -. (k /. m); 2. *. k /. m |];
|]

(* 固有ベクトルの計算 *)
let eigen_values a_mat =
  let a = Mat.of_array a_mat in
  let a_copy = lacpy a in
  geev a_copy

(* 使用例  *)
let () =
  let (lm,wr,wi,rv) = eigen_values modal_mat in
  let w_sqr = Vec.to_array wr in
  let w = Array.map sqrt w_sqr in
  Array.iter (fun elm -> print_endline (string_of_float elm)) w
 
