
open Bigarray
open Lacaml.C

let i y = { Complex.re = 0.; Complex.im = y }
let ( +< ) x z =
	{ Complex.re = x +. z.Complex.re; Complex.im = z.Complex.im }

let real { Complex.re; im } = re
let imag { Complex.re; im } = im

let plus_row u_arr v_arr =
	let dim = Array.length u_arr in
	Array.init dim (fun n -> Complex.add u_arr.(n) v_arr.(n))

let minus_row u_arr v_arr =
	let dim = Array.length u_arr in
	Array.init dim (fun n -> Complex.add u_arr.(n) v_arr.(n))
	
let prod_row c u_arr =
	let dim = Array.length u_arr in
	Array.init dim (fun n -> Complex.mul c u_arr.(n))

let ( +! ) m1 m2 =
	let dim = Array.length m1 in
	Array.init dim (fun n -> plus_row m1.(n) m2.(n))
	
let ( -! ) m1 m2 =
	let dim = Array.length m1 in
	Array.init dim (fun n -> minus_row m1.(n) m2.(n))

let ( *< ) c m =
	let dim = Array.length m in
	Array.init dim (fun n -> prod_row c m.(n))
	
let scalar u v i j =
	let len = Array.length u.(0) in
	let uv = Array.init len (fun n -> Complex.mul u.(i).(n) v.(n).(j)) in
	Array.fold_left Complex.add Complex.zero uv
	
let ( *! ) a b =
	let row = Array.length a in
	let col = Array.length b in
	let ab_row k = Array.init col (fun n -> scalar a b k n) in
	Array.init row ab_row


let eigen_values m_arr =
  let m = Mat.of_array m_arr in
  let m_copy = lacpy m in
  geev m_copy
