let pi = 4. *. atan 1.
let tpi = 8. *. atan 1.
let zeta = 0.03
let f_n = 800.
let w_n = tpi *. f_n

let rec pow a_pre a_base n =
  if n == 0 then a_pre
  else pow (a_pre *. a_base) a_base (n-1)

let ( *^ ) a n = pow 1. a n

let rpm j w =
  (30. *. w) /. ((float_of_int j)*.pi -. atan ((w*^2 -. w_n*^2) /. (2. *. zeta *. w_n *. w)))

let k1 w = 0.5 *. ((w*^2 -. w_n*^2)*^2 +. (2. *. zeta *. w_n *. w)*^2) /. (w*^2 -. w_n*^2)

let plot_stability j w =
  let rpm_value = rpm j w in
  let k1_value = k1 w in
  if rpm_value > 0. && k1_value > 0. then
    print_endline ((string_of_float rpm_value) ^ " " ^ (string_of_float k1_value))
  else ()
    
let () =
  let w_arr = Array.init 500 (fun n -> 2. *. pi *. (f_n +. (float_of_int n))) in
  let rec plot_charts n_max n =
    Array.iter (plot_stability n) w_arr;
    if n >= n_max then ()
    else plot_charts n_max (n+1)
  in
  plot_charts 10 1

  

